!-----------------------BEGIN NOTICE -- DO NOT EDIT-----------------------------
! NASA GSFC Land surface Verification Toolkit (LVT) V1.0
!-------------------------END NOTICE -- DO NOT EDIT-----------------------------
!BOP
! 
! !MODULE: WGPBMRobsMod
! \label(WGPBMRobsMod)
!
! !INTERFACE:
module WGPBMRobsMod
! 
! !USES:   
  use ESMF

  implicit none

  PRIVATE 

  PUBLIC :: WGPBMRobsinit
  PUBLIC :: WGPBMRobs
!
! !INPUT PARAMETERS: 
! 
! !OUTPUT PARAMETERS:
!
! !DESCRIPTION: 
! 
! !FILES USED:
!
! !REVISION HISTORY: 
! 
!EOP

  type, public :: wgpbmrobsdec
     character*100        :: odir
     integer              :: stnid
  end type wgpbmrobsdec

  type(wgpbmrobsdec),save:: wgpbmrobs(2)

contains
  
!BOP
! 
! !ROUTINE: WGPBMRobsInit
! \label{WGPBMRobsInit}
!
! !INTERFACE: 
  subroutine WGPBMRobsinit(i)
! 
! !USES: 
    use ESMF
    use LVT_coreMod,    only : LVT_rc, LVT_config
    use LVT_histDataMod
    use LVT_timeMgrMod, only : LVT_calendar
    use LVT_logMod,     only : LVT_verify, LVT_logunit, &
         LVT_getNextUnitNumber, LVT_releaseUnitNumber

    implicit none
!
! !INPUT PARAMETERS: 
    integer,   intent(IN) :: i 
! 
! !OUTPUT PARAMETERS:
!
! !DESCRIPTION: 
!  This subroutine initializes and sets up the data structures required
!  for reading walnut gulch PBMR data
! 
! !FILES USED:
!
! !REVISION HISTORY: 
! 
!EOP

    integer                 :: status, rc


    call ESMF_ConfigGetAttribute(LVT_Config, wgpbmrobs(i)%odir, &
         label='WG PBMR observation directory:', rc=status)
    call LVT_verify(status, 'WG PBMR observation directory: not defined')

    call ESMF_ConfigGetAttribute(LVT_Config, wgpbmrobs(i)%stnid, &
         label='WG PBMR site index:', rc=status)
    call LVT_verify(status, 'WG PBMR site index: not defined')


  end subroutine WGPBMRobsinit


end module WGPBMRobsMod
